%define _catdir /var/cache/man

%define major_version    4.3.2
%define patch_version    %{nil}

Name:		dhcp
Epoch:		3
Version:	%{major_version}%{patch_version}
%define subrel	1
Release:	%mkrel 1
Summary:	The ISC DHCP (Dynamic Host Configuration Protocol) server/relay agent/client
License:	Distributable
Group:		System/Servers
URL:		http://www.isc.org/software/dhcp
Source0:	ftp://ftp.isc.org/isc/%{name}/%{major_version}%{patch_version}/%{name}-%{major_version}%{patch_version}.tar.gz
Source1:	ftp://ftp.isc.org/isc/%{name}/%{major_version}%{patch_version}/%{name}-%{major_version}%{patch_version}.tar.gz.sha512.asc
Source2:	dhcpd.conf
Source4:	dhcp-dynamic-dns-examples.tar.bz2
Source7:	dhcpreport.pl
Source8:	dhcpd-chroot.sh
# (eugeni) dhclient-exit-hooks script
Source9:	dhclient-exit-hooks
Source11:	dhclient-hook-static-routes
Source10:	draft-ietf-dhc-ldap-schema-01.txt
Source12:	dhcpd.service
Source14:	dhcpd6.service
Source16:	dhcrelay.service
Source17:	dhcpd.tmpfiles
Source18:	dhclient.tmpfiles
Source19:	dhcrelay.tmpfiles
# mageia patches
Patch100:	dhcp-4.2.2-ifup.patch
Patch101:	dhcp-4.2.2-fix-format-errors.patch
# prevents needless deassociation, working around mdv bug #43441
Patch102:	dhcp-4.1.1-prevent_wireless_deassociation.patch
Patch103:	dhcp-4.2.5-P1-man.patch
# fedora patches
Patch7:		dhcp-4.2.0-default-requested-options.patch
Patch15:	dhcp-4.2.2-missing-ipv6-not-fatal.patch
Patch17:	dhcp-4.2.0-add_timeout_when_NULL.patch
Patch18:	dhcp-4.3.0-64_bit_lease_parse.patch
BuildRequires:	groff-for-man
BuildRequires:	openldap-devel
Requires(post):	rpm-helper >= 0.24.8-1
Requires(preun): rpm-helper >= 0.24.8-1

%description 
DHCP (Dynamic Host Configuration Protocol) is a protocol which allows 
individual devices on an IP network to get their own network configuration
information (IP address, subnetmask, broadcast address, etc.) from a DHCP
server. The overall purpose of DHCP is to make it easier to administer a 
large network. The dhcp package includes the DHCP server and a DHCP relay
agent. You will also need to install the dhcp-client or dhcpcd package,
or pump or dhcpxd, which provides the DHCP client daemon, on client machines.

If you want the DHCP server and/or relay, you will also need to install the
dhcp-server and/or dhcp-relay packages.

%package common
Summary:	The ISC DHCP (Dynamic Host Configuration Protocol) server
Group:		System/Servers

%description common
DHCP (Dynamic Host Configuration Protocol) is a protocol which allows 
individual devices on an IP network to get their own network 
configuration information (IP address, subnetmask, broadcast address, 
etc.) from a DHCP server.  The overall purpose of DHCP is to make it 
easier to administer a large network.  The dhcp package includes the 
DHCP server and a DHCP relay agent.

You will also need to install the dhcp-client or dhcpcd package, or pump or
dhcpxd, which provides the DHCP client daemon, on  client machines. If you
want the DHCP server and/or relay, you will also need to install the
dhcp-server and/or dhcp-relay packages.

%package doc
Summary:	Documentation about the ISC DHCP server/client
Group:		System/Servers

%description doc
This package contains RFC/API/protocol documentation about the ISC
DHCP server and client.

DHCP (Dynamic Host Configuration Protocol) is a protocol which allows 
individual devices on an IP network to get their own network 
configuration information (IP address, subnetmask, broadcast address, 
etc.) from a DHCP server.  The overall purpose of DHCP is to make it 
easier to administer a large network.  The dhcp package includes the 
DHCP server and a DHCP relay agent.

%package server
Summary:	The ISC DHCP (Dynamic Host Configuration Protocol) server
Group:		System/Servers
Requires:	dhcp-common = %{epoch}:%{version}-%{release}
Requires(post):  systemd >= %{systemd_required_version}
Requires(post):  rpm-helper >= 0.24.8-1
Requires(preun): rpm-helper >= 0.24.8-1

%description server
DHCP server is the Internet Software Consortium (ISC) DHCP server for various
UNIX operating systems. It allows a UNIX mac hine to serve DHCP requests from
the network.

You should install dhcp-server if you want to set up a DHCP server on your
network. You will also need to install the base dhcp package.

%package client
Summary:	The ISC DHCP (Dynamic Host Configuration Protocol) client
Group:		System/Servers
Requires:	dhcp-common = %{epoch}:%{version}-%{release}
Requires(post):  systemd >= %{systemd_required_version}
# dhclient-exit-hooks was in server package
Conflicts:	dhcp-server < 4.3.1-2

%description client
DHCP client is the Internet Software Consortium (ISC) DHCP client for various
UNIX operating systems.  It allows a UNIX mac hine to obtain it's networking
parameters from a DHCP server.

You should install dhcp-client if you want to use the ISC DHCP client instead
of the Red Hat DHCP client, pump, or dhcpcd, or dhcpxd. You will also need to
install the base dhcp package.

%package relay
Summary:	The ISC DHCP (Dynamic Host Configuration Protocol) relay
Group:		System/Servers
Requires:	dhcp-common = %{epoch}:%{version}-%{release}
Requires(post):  systemd >= %{systemd_required_version}
Requires(post):  rpm-helper >= 0.24.8-1
Requires(preun): rpm-helper >= 0.24.8-1

%description relay
DHCP relay is the Internet Software Consortium (ISC) relay agent for DHCP
packets. It is used on a subnet with DHCP clients to "relay" their requests
to a subnet that has a DHCP server on it. Because DHCP packets can be
broadcast, they will not be routed off of the local subnet. The DHCP relay
takes care of this for the client. You will need to set the environment
variable SERVERS and optionally OPTIONS in /etc/sysconfig/dhcrelay before
starting the server.

%package devel
Summary:	Development headers and libraries for the dhcpctl API
Group:		Development/Other
Requires:	dhcp-common = %{epoch}:%{version}-%{release}

%description devel
DHCP devel contains all of the libraries and headers for developing with the
Internet Software Consortium (ISC) dhcpctl API.

%prep
%setup -q -n %{name}-%{major_version}%{patch_version}
%patch100 -p1 -b .ifup
%patch101 -p1 -b .format_not_a_string_literal_and_no_format_arguments
%patch102 -p1 -b .prevent_wireless_deassociation
%patch103 -p1 -b .man

# Add NIS domain, NIS servers, NTP servers, interface-mtu and domain-search
# to the list of default requested DHCP options
%patch7 -p1 -b .requested
# If the ipv6 kernel module is missing, do not segfault
# (Submitted to dhcp-bugs@isc.org - [ISC-Bugs #19367])
%patch15 -p1 -b .noipv6
# Handle cases in add_timeout() where the function is called with a NULL
# value for the 'when' parameter
%patch17 -p1 -b .dracut
# Ensure 64-bit platforms parse lease file dates & times correctly
%patch18 -p1 -b .64-bit_lease_parse

install -m0644 %{SOURCE10} doc

%build
%serverbuild
%configure2_5x --enable-paranoia --enable-early-chroot \
    --with-ldapcrypto \
    --with-srv-lease-file=%{_var}/lib/dhcpd/dhcpd.leases \
    --with-srv6-lease-file=%{_var}/lib/dhcpd/dhcpd6.leases \
    --with-cli-lease-file=%{_var}/lib/dhclient/dhclient.leases \
    --with-cli6-lease-file=%{_var}/lib/dhclient/dhclient6.leases \
    --with-srv-pid-file=/run/dhcpd/dhcpd.pid \
    --with-srv6-pid-file=/run/dhcpd/dhcpd6.pid \
    --with-cli-pid-file=/run/dhclient/dhclient.pid \
    --with-cli6-pid-file=/run/dhclient/dhclient6.pid \
    --with-relay-pid-file=/run/dhcrelay/dhcrelay.pid
%make

%install
%makeinstall_std

# Install correct dhclient-script
install -d %{buildroot}/sbin
mv %{buildroot}%{_sbindir}/dhclient %{buildroot}/sbin/dhclient
install -m 755 client/scripts/linux %{buildroot}/sbin/dhclient-script

install -d %{buildroot}%{_unitdir}
install -m 644 %{SOURCE12} %{buildroot}%{_unitdir}/dhcpd.service
install -m 644 %{SOURCE14} %{buildroot}%{_unitdir}/dhcpd6.service
install -m 644 %{SOURCE16} %{buildroot}%{_unitdir}/dhcrelay.service

install -D -p -m 644 %{SOURCE17} %{buildroot}%{_tmpfilesdir}/dhcpd.conf
install -D -p -m 644 %{SOURCE18} %{buildroot}%{_tmpfilesdir}/dhclient.conf
install -D -p -m 644 %{SOURCE19} %{buildroot}%{_tmpfilesdir}/dhcrelay.conf

install -m 755 %{SOURCE7} %{SOURCE8} %{buildroot}%{_sbindir}
install -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}
install -m 755 contrib/ldap/dhcpd-conf-to-ldap %{buildroot}%{_sbindir}

# install exit-hooks script to /etc/
install -m 755 %{SOURCE9} %{buildroot}%{_sysconfdir}
install -d %{buildroot}%{_sysconfdir}/dhclient-exit-hooks.d
install -m 755 %{SOURCE11} %{buildroot}%{_sysconfdir}/dhclient-exit-hooks.d/static-routes.sh

install -d %{buildroot}%{_sysconfdir}/sysconfig
cat > %{buildroot}%{_sysconfdir}/sysconfig/dhcpd <<EOF
# You can set here various option for dhcpd

# Which configuration file to use.
# CONFIGFILE="/etc/dhcpd.conf"

# Where to store the lease state information.
# LEASEFILE="/var/lib/dhcpd/dhcpd.leases"

# Define INTERFACES to limit which network interfaces dhcpd listens on.
# The default null value causes dhcpd to listen on all interfaces.
#INTERFACES=""

# Define OPTIONS with any other options to pass to the dhcpd server.
# See dhcpd(8) for available options and syntax.
OPTIONS="-q"
EOF

install -d %{buildroot}%{_var}/lib/dhcpd
touch %{buildroot}%{_var}/lib/dhcpd/dhcpd.leases
install -d %{buildroot}%{_var}/lib/dhclient
touch %{buildroot}%{_var}/lib/dhclient/dhclient.leases

cat > %{buildroot}%{_sysconfdir}/sysconfig/dhcrelay <<EOF
# Define SERVERS with a list of one or more DHCP servers where
# DHCP packets are to be relayed to and from.  This is mandatory.
#SERVERS="10.11.12.13 10.9.8.7"
SERVERS=""

# Define OPTIONS with any other options to pass to the dhcrelay server.
# See dhcrelay(8) for available options and syntax.
#OPTIONS="-q -i eth0 -i eth1"
OPTIONS="-q"
EOF

find . -type d -exec chmod 0755 {} \;
find . -type f -exec chmod 0644 {} \;

rm -rf doc/ja_JP.eucJP

# remove empty files
find -size 0 |grep ldap | xargs rm -rf 

# remove unwanted file
rm -f %{buildroot}%{_sysconfdir}/dhclient.conf.example
rm -f %{buildroot}%{_sysconfdir}/dhcpd.conf.example
rm -f %{buildroot}%{_libdir}/*.a

%pre server
%_pre_useradd dhcpd /dev/null /bin/false

%post server
%_post_service dhcpd
%_tmpfilescreate dhcpd
# New dhcpd lease file
if [ ! -f %{_var}/lib/dhcpd/dhcpd.leases ]; then
    touch %{_var}/lib/dhcpd/dhcpd.leases
fi

%preun server
%_preun_service dhcpd

%post relay
%_post_service dhcrelay
%_tmpfilescreate dhcrelay

%preun relay
%_preun_service dhcrelay

%post client
touch %{_var}/lib/dhclient/dhclient.leases
%_tmpfilescreate dhclient

%postun client
rm -rf %{_var}/lib/dhclient/dhclient.leases

%files common
%doc README contrib/ldap/README.ldap RELNOTES
%doc contrib/3.0b1-lease-convert
%{_mandir}/man5/dhcp-options.5*

%files doc
%doc doc/*

%files server
%doc server/dhcpd.conf.example tests/failover contrib/ldap/dhcp.schema
%{_unitdir}/dhcpd.service
%{_unitdir}/dhcpd6.service
%{_tmpfilesdir}/dhcpd.conf
%config(noreplace) %{_sysconfdir}/dhcpd.conf
%config(noreplace) %{_sysconfdir}/sysconfig/dhcpd
%{_sbindir}/dhcpd
%{_sbindir}/dhcpreport.pl
%{_sbindir}/dhcpd-conf-to-ldap
%{_sbindir}/dhcpd-chroot.sh
%{_bindir}/omshell
%{_mandir}/man1/omshell.1*
%{_mandir}/man3/omapi.3*
%{_mandir}/man5/dhcpd.conf.5*
%{_mandir}/man5/dhcpd.leases.5*
%{_mandir}/man5/dhcp-eval.5*
%{_mandir}/man8/dhcpd.8*
%dir %{_var}/lib/dhcpd
%config(noreplace) %ghost %{_var}/lib/dhcpd/dhcpd.leases

%files relay
%{_unitdir}/dhcrelay.service
%{_tmpfilesdir}/dhcrelay.conf
%config(noreplace) %{_sysconfdir}/sysconfig/dhcrelay
%{_sbindir}/dhcrelay
%{_mandir}/man8/dhcrelay.8*

%files client
%doc client/dhclient.conf.example
%{_sysconfdir}/dhclient-exit-hooks
%{_sysconfdir}/dhclient-exit-hooks.d
%attr (0755,root,root) /sbin/dhclient-script
%{_tmpfilesdir}/dhclient.conf
/sbin/dhclient
%{_mandir}/man5/dhclient.conf.5*
%{_mandir}/man5/dhclient.leases.5*
%{_mandir}/man8/dhclient.8*
%{_mandir}/man8/dhclient-script.8*
%dir %{_var}/lib/dhclient
%config(noreplace) %ghost %{_var}/lib/dhclient/dhclient.leases

%files devel
%{_includedir}/*
%{_mandir}/man3/*


%changelog
* Sat Sep 12 2015 luigiwalser <luigiwalser> 3:4.3.2-1.1.mga5
+ Revision: 878319
- fix starting service when network.target is not active (mga#16642)

* Fri Mar 06 2015 luigiwalser <luigiwalser> 3:4.3.2-1.mga5
+ Revision: 817932
- 4.3.2
- remove fedora patch patch8 (removed by fedora, probably upstreamed)
- rediff patch 101

* Wed Oct 15 2014 umeabot <umeabot> 3:4.3.1-5.mga5
+ Revision: 740950
- Second Mageia 5 Mass Rebuild

* Wed Sep 17 2014 pterjan <pterjan> 3:4.3.1-4.mga5
+ Revision: 693128
- Fix hooks script

  + umeabot <umeabot>
    - Mageia 5 Mass Rebuild

* Tue Sep 16 2014 pterjan <pterjan> 3:4.3.1-2.mga5
+ Revision: 677104
- Move static-routes dhclient hook to the client package (mga#6752)
- Allow having other dhclient hooks

* Tue Aug 12 2014 luigiwalser <luigiwalser> 3:4.3.1-1.mga5
+ Revision: 662049
- 4.3.1
- rediff patch 101

* Sun Jun 15 2014 luigiwalser <luigiwalser> 3:4.3.0-1.mga5
+ Revision: 636554
- 4.3.0
- rediff patches 101, 8, and 18

* Sat Oct 19 2013 umeabot <umeabot> 3:4.2.5P1-2.mga4
+ Revision: 522813
- Mageia 4 Mass Rebuild

* Thu Mar 28 2013 oden <oden> 3:4.2.5P1-1.mga3
+ Revision: 405980
- P103: rediff
- 4.2.5-P1 (fixes CVE-2013-2494)
- drop bogus br on bind-devel
- Make sure ldap service is started before dhcpd (neoclust)

* Sun Mar 24 2013 colin <colin> 3:4.2.4P2-5.mga3
+ Revision: 405136
- Use tmpfiles macros and add system version to requires (mga#9302)

* Fri Jan 11 2013 umeabot <umeabot> 3:4.2.4P2-4.mga3
+ Revision: 348757
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Wed Dec 26 2012 guillomovitch <guillomovitch> 3:4.2.4P2-3.mga3
+ Revision: 335360
- add fedora patch adding requesting more options by default

* Mon Dec 17 2012 guillomovitch <guillomovitch> 3:4.2.4P2-2.mga3
+ Revision: 332185
- drop static libs
- use /run instead of /var/run for pid files
- switch to tmpfs for /run subdirectories
- use distinct state directories for client and server, as in fedora

* Thu Sep 13 2012 luigiwalser <luigiwalser> 3:4.2.4P2-1.mga3
+ Revision: 293669
- 4.2.4-P2 (fixes CVE-2012-3955)

* Tue Jul 31 2012 guillomovitch <guillomovitch> 3:4.2.4P1-1.mga3
+ Revision: 276555
- drop sysinit support
- new version

* Sat Apr 28 2012 tmb <tmb> 3:4.2.3P2-6.mga2
+ Revision: 233666
- Require rpm-helper >= 0.24.8-1 for systemd support
- rebuild for versioned rpm-helper requires

* Wed Mar 14 2012 stewb <stewb> 3:4.2.3P2-4.mga2
+ Revision: 223343
- Get rid of mandrakesoft in dhcpd.conf (mageia bug #3353)

* Mon Mar 12 2012 colin <colin> 3:4.2.3P2-3.mga2
+ Revision: 223169
- Fix systemd units to report correct status on startup (mga#4892)

* Tue Jan 31 2012 dmorgan <dmorgan> 3:4.2.3P2-2.mga2
+ Revision: 203651
- Add dhcpd user
- Fix service files extension

* Sun Jan 15 2012 fwang <fwang> 3:4.2.3_P2-1.mga2
+ Revision: 196496
- new version 4.2.3p2

* Fri Dec 30 2011 anssi <anssi> 3:4.2.3_P1-1.mga2
+ Revision: 188952
- new version 4.2.3-P1 (fixes CVE-2011-4539)

* Sun Nov 20 2011 zezinho <zezinho> 3:4.2.3-1.mga2
+ Revision: 169838
- new version

* Mon Sep 12 2011 guillomovitch <guillomovitch> 3:4.2.2-3.mga2
+ Revision: 142670
- resync ipv6-not-fatal patch with fedora
- add 3 new fedora patches
 * dhcp-4.2.0-add_timeout_when_NULL.patch
 * dhcp-4.2.1-64_bit_lease_parse.patch
 * dhcp-4.2.2-xen-checksum.patch (attempt to fix #1243)

* Tue Sep 06 2011 guillomovitch <guillomovitch> 3:4.2.2-2.mga2
+ Revision: 139289
- sync init scripts with fedora (lsb headers, mostly)
- ship systemd service files

* Tue Aug 30 2011 guillomovitch <guillomovitch> 3:4.2.2-1.mga2
+ Revision: 136450
- add missing LSB header
- new version
- rediff ifup and format-errors patches
- drop wait patch, merged upstream (according to fedora)
- drop prehistoric dhcp 2 -> 3 upgrade script
- spec cleanup

  + tv <tv>
    - add missing LSB keywords

* Sun May 15 2011 pterjan <pterjan> 3:4.2.1-0.P1.3.mga1
+ Revision: 98933
- Rebuild for fixed find-requires

* Thu Apr 14 2011 pterjan <pterjan> 3:4.2.1-0.P1.2.mga1
+ Revision: 84812
- Re-upload after upload bug

* Wed Apr 13 2011 tv <tv> 3:4.2.1-0.P1.1.mga1
+ Revision: 84559
- 4.2.1-P1
- drop upstream added patch 8
- Added sample dhclient-exit-hooks, initially handling
  rfc3442_classless_static_routes (suggested in #62242).

  + dmorgan <dmorgan>
    - imported package dhcp

